import sys
import pyromod.listen

from pyrogram import Client as RawClient
from pyrogram.errors import (
    AuthKeyDuplicated,
    AuthKeyUnregistered,
    SessionRevoked,
    UserDeactivated,
    UserDeactivatedBan,
    SessionPasswordNeeded,
)
from .database import Database
from .decorators import Decorators
from .methods import Methods
from .types import Types
from .utilities import Utilities


class _AbstractCli(
    Database, 
    Decorators, 
    Methods, 
    Types,
    Utilities,
):
    pass


class Client(RawClient, _AbstractCli):
    def __init__(
        self,
        **kwargs,
    ):
        super().__init__(
            name=kwargs["name"],
            api_id=kwargs["api_id"],
            api_hash=kwargs["api_hash"],
            bot_token=kwargs["bot_token"]
        )
        
        
    async def start(self):
        await super().start()
        await self.Media.ensure_indexes()
        await self.Media2.ensure_indexes()
        string = await self.get_session()
        me = await self.get_me()
        self.id = me.id
        self.name = me.first_name
        self.username = me.username
    
        self.vip = self.VipCli()
        self.inx = self.InxCli()
        self.pob = self.PobCli()
        self.pap = self.PapCli()
        self.bcl = self.BclCli()
        self.bdb = self.BdbCli()
        self.pmo = self.PmoCli()
        self.vipbot = self.VipBotCli()
        self.bub = self.BubCli()
   
        try:
            self.channel_db = await self.get_chat(self.OTH_CONTENT)
        except Exception as e:
            self.logs.warning(e)
            self.logs.warning(f"Pastikan bot adalah Admin di OTH Content DB")
            sys.exit()
            
        if string:
            for session in string:
                bot_ = RawClient(
                    "NewUserbot",
                    api_id=self.API_ID,
                    api_hash=self.API_HASH,
                    device_model="@OnTheHerd",
                    session_string=session,
                    plugins={"root": "Tele.userbot"},
                )
                try:
                    await bot_.start()
                except AuthKeyDuplicated:
                    await self.del_session(session)
                except AuthKeyUnregistered:
                    await self.del_session(session)
                except SessionRevoked:
                    await self.del_session(session)
                except SessionPasswordNeeded:
                    await self.del_session(session)
                except UserDeactivated:
                    await self.del_session(session)
                except UserDeactivatedBan:
                    await self.del_session(session)
                self.rawbot.append(bot_)
                try:
                    mebot = await bot_.get_me()
                    self.logs.info(f"Userbot Started !\nName: {mebot.first_name}\nUserID: {mebot.id}")
                except BaseException:
                    pass
        self.BLCHAT.append(self.id)
        self.logs.info(f"OTH Started !\nName: {self.name}\nUserID: {self.id}")     
    
    async def stop(self, *args):
        await super().stop()
        
        
    class VipCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "VipNewUbot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                session_string=self.SESSION,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            try:
                self.index = await self.get_chat(self.VIP_INDEX_ID)
                self.index_live = await self.get_chat(self.VIP_INDEX_LIVE)
                self.index_asia = await self.get_chat(self.VIP_INDEX_ASIA)
                self.index_indo = await self.get_chat(self.VIP_INDEX_INDO)
                self.index_bocil = await self.get_chat(self.VIP_INDEX_BOCIL)
                self.index_hijab = await self.get_chat(self.VIP_INDEX_HIJAB)
                self.index_random = await self.get_chat(self.VIP_INDEX_RANDOM)
                self.index_koleksi = await self.get_chat(self.VIP_INDEX_KOLEKSI)
                self.index_onlyfans = await self.get_chat(self.VIP_INDEX_ONLYFANS)
  
                self.vip_live = await self.get_chat(self.VIP_LIVE)
                self.vip_asia = await self.get_chat(self.VIP_ASIA)
                self.vip_indo = await self.get_chat(self.VIP_INDO)
                self.vip_bocil = await self.get_chat(self.VIP_BOCIL)
                self.vip_hijab = await self.get_chat(self.VIP_HIJAB)
                self.vip_random = await self.get_chat(self.VIP_RANDOM)
                self.vip_koleksi = await self.get_chat(self.VIP_KOLEKSI)
                self.vip_onlyfans = await self.get_chat(self.VIP_ONLYFANS)
            except Exception as e:
                self.logs.warning(e)
                sys.exit()
      
            self.logs.info(f"Ubot Vip Started !\nName: {self.name}\nUserID: {self.id}")
      
        async def stop(self, *args):
            await super().stop()
            
            
    class InxCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "InxNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN2,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            try:
                self.channel_db = await self.get_chat(self.OTH_INDEX)
            except Exception as e:
                self.logs.warning(e)
                self.logs.warning(f"Pastikan bot adalah Admin di OTH Index DB")
                sys.exit()
            
            self.BLCHAT.append(self.id)
            self.logs.info(f"Index Started !\nName: {self.name}\nUserID: {self.id}")
      
        async def stop(self, *args):
            await super().stop()
            
            
    class PobCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "PobNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN3,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            try:
                self.channel_db = await self.get_chat(self.POB_INDEX)
            except Exception as e:
                self.logs.warning(e)
                self.logs.warning(f"Pastikan bot adalah Admin di POB Index DB")
                sys.exit()
            
            self.BLCHAT.append(self.id)
            self.logs.info(f"POB Started !\nName: {self.name}\nUserID: {self.id}")
      
        async def stop(self, *args):
            await super().stop()
      
      
    class PapCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "PapNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN4,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            try:
                self.channel_db = await self.get_chat(self.PAP_INDEX)
            except Exception as e:
                self.logs.warning(e)
                self.logs.warning(f"Pastikan bot adalah Admin di Channel DB Rate")
                sys.exit()
            self.BLCHAT.append(self.id)
            self.logs.info(f"PAP Started !\nName: {self.name}\nUserID: {self.id}")
            
        async def stop(self, *args):
            await super().stop()
            
            
    class BclCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "BclNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN5,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            try:
                self.channel_db = await self.get_chat(self.BCL_INDEX)
            except Exception as e:
                self.logs.warning(e)
                self.logs.warning(f"Pastikan bot adalah Admin di Channel DB Bocil")
                sys.exit()
            self.BLCHAT.append(self.id)
            self.logs.info(f"BCL Started !\nName: {self.name}\nUserID: {self.id}")
          
        async def stop(self, *args):
            await super().stop()
            
            
    class BdbCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "BdbNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN6,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            self.logs.info(f"BDB Started !\nName: {self.name}\nUserID: {self.id}")

            premium = await self.get_premium_name2()
            if premium:
                for user_id in premium:
                    prems = await self.get_premium2(str(user_id))
                    name = prems["name"] 
                    joined = prems["joined"]
                    session = prems["string"]
                    userid = prems["userid"] 
                    status = prems["status"] 
                    expires = prems["expires"] 
                    if session != "":
                        bot_ = RawClient(
                            "BDBNewUbot",
                            api_id=self.API_ID,
                            api_hash=self.API_HASH,
                            device_model="YourBDB",
                            session_string=session,
                            plugins={"root": "Tele.plugins.bdb"},
                        )
                        try:
                            await bot_.start()
                        except AuthKeyDuplicated:
                            prem = {
                                "name": name,
                                "joined": joined,
                                "string": "",
                                "userid": userid,
                                "status": status,
                                "expires": expires
                            }
                            await self.add_premium2(str(user_id), prem)
                        except AuthKeyUnregistered:
                            prem = {
                                "name": name,
                                "joined": joined,
                                "string": "",
                                "userid": userid,
                                "status": status,
                                "expires": expires
                            }
                            await self.add_premium2(str(user_id), prem)
                        except SessionRevoked:
                            prem = {
                                "name": name,
                                "joined": joined,
                                "string": "",
                                "userid": userid,
                                "status": status,
                                "expires": expires
                            }
                            await self.add_premium2(str(user_id), prem)
                        except SessionPasswordNeeded:
                            prem = {
                                "name": name,
                                "joined": joined,
                                "string": "",
                                "userid": userid,
                                "status": status,
                                "expires": expires
                            }
                            await self.add_premium2(str(user_id), prem)
                        except UserDeactivated:
                            prem = {
                                "name": name,
                                "joined": joined,
                                "string": "",
                                "userid": userid,
                                "status": status,
                                "expires": expires
                            }
                            await self.add_premium2(str(user_id), prem)
                        except UserDeactivatedBan:
                            prem = {
                                "name": name,
                                "joined": joined,
                                "string": "",
                                "userid": userid,
                                "status": status,
                                "expires": expires
                            }
                            await self.add_premium2(str(user_id), prem)
                        self.bdbubot.append(bot_)
                        mebot = await bot_.get_me()
                        self.logs.info(f"BDB Userbot Started !\nName: {mebot.first_name}\nUserID: {mebot.id}")
                    
        async def stop(self, *args):
            await super().stop()


    class PmoCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "PmoNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN7,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            try:
                self.channel_db = await self.get_chat(self.PMO_INDEX)
            except Exception as e:
                self.logs.warning(e)
                self.logs.warning(f"Pastikan bot adalah Admin di Channel DB PMO")
                sys.exit()

            self.BLCHAT.append(self.id)
            self.logs.info(f"PMO Started !\nName: {self.name}\nUserID: {self.id}")
            
        async def stop(self, *args):
            await super().stop()


    class VipBotCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "VipNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN8,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            try:
                self.vip_live = await self.get_chat(self.VIP_LIVE)
                self.vip_asia = await self.get_chat(self.VIP_ASIA)
                self.vip_indo = await self.get_chat(self.VIP_INDO)
                self.vip_bocil = await self.get_chat(self.VIP_BOCIL)
                self.vip_hijab = await self.get_chat(self.VIP_HIJAB)
                self.vip_random = await self.get_chat(self.VIP_RANDOM)
                self.vip_koleksi = await self.get_chat(self.VIP_KOLEKSI)
                self.vip_onlyfans = await self.get_chat(self.VIP_ONLYFANS)
            except Exception as e:
                self.logs.warning(e)
                sys.exit()
      
            self.logs.info(f"Bot Vip Started !\nName: {self.name}\nUserID: {self.id}")
      
        async def stop(self, *args):
            await super().stop()


    class BubCli(RawClient, _AbstractCli):
        def __init__(self):
            super().__init__(
                "BubNewBot",
                api_id=self.API_ID,
                api_hash=self.API_HASH,
                bot_token=self.BOT_TOKEN9,
            )
      
        async def start(self):
            await super().start()
            me = await self.get_me()
            self.id = me.id
            self.name = me.first_name
            self.username = me.username
      
            self.logs.info(f"BUB Started !\nName: {self.name}\nUserID: {self.id}")

            list = await self.list_user_bub()
            if list:
                for user_id in list:
                    u = await self.get_user_bub(str(user_id))
                    name = u["name"] 
                    userid = u["userid"]
                    string = u["string"]
                    status = u["string"]
                    joined = u["joined"] 
                    expires = u["expires"] 
                    if string != "":
                        bot_ = RawClient(
                            "BUBNewUbot",
                            api_id=self.API_ID,
                            api_hash=self.API_HASH,
                            device_model="BokepUBot",
                            session_string=string,
                            plugins={"root": "Tele.plugins.bub"},
                        )
                        try:
                            await bot_.start()
                        except AuthKeyDuplicated:
                            user = {
                                "name": name,
                                "userid": userid,
                                "string": "",
                                "status": "basic",
                                "joined": joined,
                                "expires": expires
                            }
                            await self.add_user_bub(str(user_id), user)
                        except AuthKeyUnregistered:
                            user = {
                                "name": name,
                                "userid": userid,
                                "string": "",
                                "status": "basic",
                                "joined": joined,
                                "expires": expires
                            }
                            await self.add_user_bub(str(user_id), user)
                        except SessionRevoked:
                            user = {
                                "name": name,
                                "userid": userid,
                                "string": "",
                                "status": "basic",
                                "joined": joined,
                                "expires": expires
                            }
                            await self.add_user_bub(str(user_id), user)
                        except SessionPasswordNeeded:
                            user = {
                                "name": name,
                                "userid": userid,
                                "string": "",
                                "status": "basic",
                                "joined": joined,
                                "expires": expires
                            }
                            await self.add_user_bub(str(user_id), user)
                        except UserDeactivated:
                            user = {
                                "name": name,
                                "userid": userid,
                                "string": "",
                                "status": "basic",
                                "joined": joined,
                                "expires": expires
                            }
                            await self.add_user_bub(str(user_id), user)
                        except UserDeactivatedBan:
                            user = {
                                "name": name,
                                "userid": userid,
                                "string": "",
                                "status": "basic",
                                "joined": joined,
                                "expires": expires
                            }
                            await self.add_user_bub(str(user_id), user)
                        self.bububot.append(bot_)
                        mebot = await bot_.get_me()
                        self.userbub.append(mebot.id)
                        self.logs.info(f"BUB Userbot Started !\nName: {mebot.first_name}\nUserID: {mebot.id}")
                    
        async def stop(self, *args):
            await super().stop()
