class bdbDatabase:
    # Premium
    async def _get_premium2(self) -> dict:
        _notes = await self.premdb2.find_one({"prem": "prem"})
        if not _notes:
            return {}
        return _notes["notes"]

    async def get_premium_name2(self) -> list:
        _notes = []
        for note in await self._get_premium2():
            _notes.append(note)
        return _notes

    async def get_premium2(self, name: str) -> bool:
        name = name
        _notes = await self._get_premium2()
        if name in _notes:
            return _notes[name]
        else:
            return False

    async def add_premium2(self, name: str, note: dict):
        name = name
        _notes = await self._get_premium2()
        _notes[name] = note
        await self.premdb2.update_one(
            {"prem": "prem"}, {"$set": {"notes": _notes}}, upsert=True
        )

    async def del_premium2(self, name: str) -> bool:
        notesd = await self._get_premium2()
        name = name
        if name in notesd:
            del notesd[name]
            await self.premdb2.update_one(
                {"prem": "prem"}, {"$set": {"notes": notesd}}, upsert=True
            )
            return True
        return False


    # Users
    async def get_user_bdb(self) -> list:
        results = []
        async for user in self.usersdb3.find({"user_id": {"$gt": 0}}):
            user_id = user["user_id"]
            results.append(user_id)
        return results

    async def is_user_bdb(self, user_id: int) -> bool:
        user = await self.usersdb3.find_one({"user_id": user_id})
        if not user:
            return False
        return True

    async def add_user_bdb(self, user_id: int):
        is_served = await self.is_user_bdb(user_id)
        if is_served:
            return
        return await self.usersdb3.insert_one({"user_id": user_id})

    async def del_user_bdb(self, user_id: int):
        is_served = await self.is_user_bdb(user_id)
        if not is_served:
            return
        return await self.usersdb3.delete_one({"user_id": user_id})


    # Content
    async def _get_content(self) -> dict:
        _notes = await self.ctndb.find_one({"cont": "cont"})
        if not _notes:
            return {}
        return _notes["notes"]

    async def get_content_name(self) -> list:
        _notes = []
        for note in await self._get_content():
            _notes.append(note)
        return _notes

    async def get_content(self, name: str) -> bool:
        name = name
        _notes = await self._get_content()
        if name in _notes:
            return _notes[name]
        else:
            return False

    async def add_content(self, name: str, note: dict):
        name = name
        _notes = await self._get_content()
        _notes[name] = note
        await self.ctndb.update_one(
            {"cont": "cont"}, {"$set": {"notes": _notes}}, upsert=True
        )

    async def del_content(self, name: str) -> bool:
        notesd = await self._get_content()
        name = name
        if name in notesd:
            del notesd[name]
            await self.ctndb.update_one(
                {"cont": "cont"}, {"$set": {"notes": notesd}}, upsert=True
            )
            return True
        return False


    # Trial 
    async def get_trial_bdb(self) -> list:
        results = []
        async for trial in self.trialdb2.find({"user_id": {"$gt": 0}}):
            user_id = trial["user_id"]
            results.append(user_id)
        return results

    async def is_trial_bdb(self, user_id: int) -> bool:
        trial = await self.trialdb2.find_one({"user_id": user_id})
        if not trial:
            return False
        return True

    async def add_trial_bdb(self, user_id: int):
        is_trials = await self.is_trial_bdb(user_id)
        if is_trials:
            return
        return await self.trialdb2.insert_one({"user_id": user_id})

    async def del_trial_bdb(self, user_id: int):
        is_trials = await self.is_trial_bdb(user_id)
        if not is_trials:
            return
        return await self.trialdb2.delete_one({"user_id": user_id})


    # Admins
    async def get_admin_bdb(self) -> list:
        admins = await self.admindb.find_one({"adm": "adm"})
        if not admins:
            return []
        return admins["admins"]

    async def add_admin_bdb(self, user_id: int) -> bool:
        admins = await self.get_admin_bdb()
        admins.append(user_id)
        await self.admindb.update_one(
            {"adm": "adm"}, {"$set": {"admins": admins}}, upsert=True
        )
        return True

    async def del_admin_bdb(self, user_id: int) -> bool:
        admins = await self.get_admin_bdb()
        admins.remove(user_id)
        await self.admindb.update_one(
            {"adm": "adm"}, {"$set": {"admins": admins}}, upsert=True
        )
        return True


    # File Unique
    async def get_file_bdb(self) -> list:
        unique = await self.filedb.find_one({"uni": "uni"})
        if not unique:
            return []
        return unique["unique"]

    async def add_file_bdb(self, unique_id: str) -> bool:
        unique = await self.get_file_bdb()
        unique.append(unique_id)
        await self.filedb.update_one(
            {"uni": "uni"}, {"$set": {"unique": unique}}, upsert=True
        )
        return True

    async def del_file_bdb(self, unique_id: str) -> bool:
        unique = await self.get_file_bdb()
        unique.remove(unique_id)
        await self.filedb.update_one(
            {"uni": "uni"}, {"$set": {"unique": unique}}, upsert=True
        )
        return True
