class othDatabase:
    # Premium
    async def _get_premium(self) -> dict:
        _notes = await self.premdb.find_one({"prem": "prem"})
        if not _notes:
            return {}
        return _notes["notes"]

    async def get_premium_name(self) -> list:
        _notes = []
        for note in await self._get_premium():
            _notes.append(note)
        return _notes

    async def get_premium(self, name: str) -> bool:
        name = name
        _notes = await self._get_premium()
        if name in _notes:
            return _notes[name]
        else:
            return False

    async def add_premium(self, name: str, note: dict):
        name = name
        _notes = await self._get_premium()
        _notes[name] = note
        await self.premdb.update_one(
            {"prem": "prem"}, {"$set": {"notes": _notes}}, upsert=True
        )

    async def del_premium(self, name: str) -> bool:
        notesd = await self._get_premium()
        name = name
        if name in notesd:
            del notesd[name]
            await self.premdb.update_one(
                {"prem": "prem"}, {"$set": {"notes": notesd}}, upsert=True
            )
            return True
        return False


    # Session
    async def get_session(self) -> list:
        session = await self.sessiondb.find_one({"ubot": "ubot"})
        if not session:
            return []
        return session["session"]
    
    async def add_session(self, string: str) -> bool:
        session = await self.get_session()
        session.append(string)
        await self.sessiondb.update_one(
            {"ubot": "ubot"}, {"$set": {"session": session}}, upsert=True
        )
        return True
    
    async def del_session(self, string: str) -> bool:
        session = await self.get_session()
        session.remove(string)
        await self.sessiondb.update_one(
            {"ubot": "ubot"}, {"$set": {"session": session}}, upsert=True
        )
        return True


    # Users
    async def get_user(self) -> list:
        results = []
        async for user in self.usersdb.find({"user_id": {"$gt": 0}}):
            user_id = user["user_id"]
            results.append(user_id)
        return results

    async def is_user(self, user_id: int) -> bool:
        user = await self.usersdb.find_one({"user_id": user_id})
        if not user:
            return False
        return True

    async def add_user(self, user_id: int):
        is_served = await self.is_user(user_id)
        if is_served:
            return
        return await self.usersdb.insert_one({"user_id": user_id})

    async def del_user(self, user_id: int):
        is_served = await self.is_user(user_id)
        if not is_served:
            return
        return await self.usersdb.delete_one({"user_id": user_id})


    # Promo
    async def get_promo(self) -> list:
        promo = await self.promodb.find_one({"code": "code"})
        if not promo:
            return []
        return promo["promo"]
    
    async def add_promo(self, user_id: int) -> bool:
        promo = await self.get_promo()
        promo.append(user_id)
        await self.promodb.update_one(
            {"code": "code"}, {"$set": {"promo": promo}}, upsert=True
        )
        return True
    
    async def del_promo(self, user_id: int) -> bool:
        promo = await self.get_promo()
        promo.remove(user_id)
        await self.promodb.update_one(
            {"code": "code"}, {"$set": {"promo": promo}}, upsert=True
        )
        return True


    # Trial 
    async def get_trial(self) -> list:
        results = []
        async for trial in self.trialdb.find({"user_id": {"$gt": 0}}):
            user_id = trial["user_id"]
            results.append(user_id)
        return results

    async def is_trial(self, user_id: int) -> bool:
        trial = await self.trialdb.find_one({"user_id": user_id})
        if not trial:
            return False
        return True

    async def add_trial(self, user_id: int):
        is_trials = await self.is_trial(user_id)
        if is_trials:
            return
        return await self.trialdb.insert_one({"user_id": user_id})

    async def del_trial(self, user_id: int):
        is_trials = await self.is_trial(user_id)
        if not is_trials:
            return
        return await self.trialdb.delete_one({"user_id": user_id})


    # Price
    async def get_pricenum(self) -> int:
        num = 98324
        price = await self.pricedb.find_one({"num": num})
        if not price:
            return 0
        return price["number"]

    async def set_pricenum(self, number: int):
        num = 98324
        return await self.pricedb.update_one(
            {"num": num}, {"$set": {"number": number}}, upsert=True
        )


    # On Off
    async def is_on_off(self, on_off: int) -> bool:
        onoff = await self.onoffdb.find_one({"on_off": on_off})
        if not onoff:
            return False
        return True

    async def add_on(self, on_off: int):
        is_on = await self.is_on_off(on_off)
        if is_on:
            return
        return await self.onoffdb.insert_one({"on_off": on_off})

    async def add_off(self, on_off: int):
        is_off = await self.is_on_off(on_off)
        if not is_off:
            return
        return await self.onoffdb.delete_one({"on_off": on_off})


    # Voting
    async def is_voted(self, msg_id, user_id):
        msg_id = "a" + str(msg_id)
        votes = await self.votedb.find_one({"msg_id": msg_id})
        if votes == None:
            return 0
        if user_id not in votes["users"]:
            return 0
        return 1

    async def save_vote(self, msg_id, user_id):
        msg_id = "a" + str(msg_id)
        data = await self.votedb.update_one({"msg_id": msg_id}, {"$addToSet": {"users": user_id}}, upsert=True)
        return
