class papDatabase:
    # List Users
    async def get_user_pap(self) -> list:
        results = []
        async for user in self.usersdb2.find({"user_id": {"$gt": 0}}):
            user_id = user["user_id"]
            results.append(user_id)
        return results

    async def is_user_pap(self, user_id: int) -> bool:
        user = await self.usersdb2.find_one({"user_id": user_id})
        if not user:
            return False
        return True

    async def add_user_pap(self, user_id: int):
        is_served = await self.is_user_pap(user_id)
        if is_served:
            return
        return await self.usersdb2.insert_one({"user_id": user_id})

    async def del_user_pap(self, user_id: int):
        is_served = await self.is_user_pap(user_id)
        if not is_served:
            return
        return await self.usersdb2.delete_one({"user_id": user_id})


    # Rating Users
    async def get_rate(self) -> list:
        rating = await self.ratingdb.find_one({"rate": "rate"})
        if not rating:
            return []
        return rating["rating"]

    async def add_rate(self, user_id: int) -> bool:
        rating = await self.get_rate()
        rating.append(user_id)
        await self.ratingdb.update_one(
            {"rate": "rate"}, {"$set": {"rating": rating}}, upsert=True
        )
        return True
   
    async def del_rate(self, user_id: int) -> bool:
        rating = await self.get_rate()
        rating.remove(user_id)
        await self.ratingdb.update_one(
            {"rate": "rate"}, {"$set": {"rating": rating}}, upsert=True
        )
        return True
