class pmoDatabase:
    # Schedule
    async def _get_schedule(self) -> dict:
        _notes = await self.scheduledb.find_one({"schedule": "schedule"})
        if not _notes:
            return {}
        return _notes["notes"]

    async def get_schedule_name(self) -> list:
        _notes = []
        for note in await self._get_schedule():
            _notes.append(note)
        return _notes

    async def get_schedule(self, name: str) -> bool:
        name = name
        _notes = await self._get_schedule()
        if name in _notes:
            return _notes[name]
        else:
            return False

    async def add_schedule(self, name: str, note: dict):
        name = name
        _notes = await self._get_schedule()
        _notes[name] = note
        await self.scheduledb.update_one(
            {"schedule": "schedule"}, {"$set": {"notes": _notes}}, upsert=True
        )

    async def del_schedule(self, name: str) -> bool:
        notesd = await self._get_schedule()
        name = name
        if name in notesd:
            del notesd[name]
            await self.scheduledb.update_one(
                {"schedule": "schedule"}, {"$set": {"notes": notesd}}, upsert=True
            )
            return True
        return False


    # Users
    async def get_user_pmo(self) -> list:
        results = []
        async for user in self.usersdb4.find({"user_id": {"$gt": 0}}):
            user_id = user["user_id"]
            results.append(user_id)
        return results

    async def is_user_pmo(self, user_id: int) -> bool:
        user = await self.usersdb4.find_one({"user_id": user_id})
        if not user:
            return False
        return True

    async def add_user_pmo(self, user_id: int):
        is_served = await self.is_user_pmo(user_id)
        if is_served:
            return
        return await self.usersdb4.insert_one({"user_id": user_id})

    async def del_user_pmo(self, user_id: int):
        is_served = await self.is_user_pmo(user_id)
        if not is_served:
            return
        return await self.usersdb4.delete_one({"user_id": user_id})


    # Admins
    async def get_admin(self) -> list:
        admins = await self.admindb2.find_one({"adm": "adm"})
        if not admins:
            return []
        return admins["admins"]


    async def add_admin(self, user_id: int) -> bool:
        admins = await self.get_admin()
        admins.append(user_id)
        await self.admindb2.update_one(
            {"adm": "adm"}, {"$set": {"admins": admins}}, upsert=True
        )
        return True


    async def del_admin(self, user_id: int) -> bool:
        admins = await self.get_admin()
        admins.remove(user_id)
        await self.admindb2.update_one(
            {"adm": "adm"}, {"$set": {"admins": admins}}, upsert=True
        )
        return True
