import random
from pyrogram.errors import ChatAdminRequired, ChatWriteForbidden, UserNotParticipant
from pyrogram.enums import ChatMemberStatus
from pyrogram.types import InlineKeyboardMarkup


STATUS = [ChatMemberStatus.OWNER, ChatMemberStatus.ADMINISTRATOR, ChatMemberStatus.MEMBER]


class ForceSub:
    def decorators(self, func):
        async def wrapper(client, message):
            if (
                not self.OTH_CHANNEL 
                and not self.OTH_BACKUP
                and not self.OTH_GROUP
                and not self.OTH_TESTI
            ):  # Tidak wajib
                return
            user = await self.get_users(message.from_user.id)
            if user.id not in self.OWNER_ID:
                if not await self.is_user(user.id):
                    await self.send_message(
                        chat_id=self.OTH_LOGS,
                        text=f"**#NEW_USER**\n\n**Name:** {user.mention}\n**UserID:** `{user.id}`",
                    )
                    await self.add_user(user.id)
                try:
                    oth_c = await self.get_chat_member(self.OTH_CHANNEL, user.id)
                    if oth_c.status not in STATUS:
                        info_c = await self.get_chat(self.OTH_CHANNEL)
                        return await message.reply_text(
                            text=f"**Anda harus bergabung dengan [channel]({info_c.invite_link}) saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True
                        )
                    oth_b = await self.get_chat_member(self.OTH_BACKUP, user.id)
                    if oth_b.status not in STATUS:
                        info_b = await self.get_chat(self.OTH_BACKUP)
                        return await message.reply_text(
                            text=f"**Anda harus bergabung dengan [channel]({info_b.invite_link}) saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True
                        )
                    oth_g = await self.get_chat_member(self.OTH_GROUP, user.id)
                    if oth_g.status not in STATUS:
                        info_g = await self.get_chat(self.OTH_GROUP)
                        return await message.reply_text(
                            text=f"**Anda harus bergabung dengan [channel]({info_g.invite_link}) saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True
                        )
                    oth_t = await self.get_chat_member(self.OTH_TESTI, user.id)
                    if oth_t.status not in STATUS:
                        info_t = await self.get_chat(self.OTH_TESTI)
                        return await message.reply_text(
                            text=f"**Anda harus bergabung dengan [channel]({info_t.invite_link}) saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True
                        )
                except UserNotParticipant:
                    chat1 = await self.get_chat(self.OTH_CHANNEL)
                    chat2 = await self.get_chat(self.OTH_BACKUP)
                    chat3 = await self.get_chat(self.OTH_GROUP)
                    chat4 = await self.get_chat(self.OTH_TESTI)
                    try:
                        await message.reply_text(
                            text=f"**Anda harus bergabung dengan channel saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True,
                            reply_markup=InlineKeyboardMarkup(
                                self.fsub_markup(
                                    message, chat1.invite_link, 
                                    chat2.invite_link, chat3.invite_link, chat4.invite_link,
                                )
                            ),
                        )
                        await message.stop_propagation()
                    except ChatWriteForbidden:
                        pass
            return await func(client, message)

        return wrapper


    def decorators2(self, func):
        async def wrapper(client, message):
            if (
                not self.OTH_CHANNEL
                and not self.PMO_CHANNEL
            ):  # Tidak wajib
                return
            chat_id = random.choice(self.FSCHAT)
            user_id = message.from_user.id
            user = await self.get_users(user_id)
            if user.id not in self.OWNER_ID:
                try:
                    oth_c = await self.get_chat_member(self.OTH_CHANNEL, user.id)
                    if oth_c.status not in STATUS:
                        info_c = await self.get_chat(self.OTH_CHANNEL)
                        return await message.reply_text(
                            text=f"**Anda harus bergabung dengan [channel]({info_c.invite_link}) saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True
                        )
                    chat_r = await self.get_chat_member(chat_id, user.id)
                    if chat_r.status not in STATUS:
                        info_r = await self.get_chat(chat_id)
                        return await message.reply_text(
                            text=f"**Anda harus bergabung dengan [channel]({info_r.invite_link}) saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True
                        )
                except UserNotParticipant:
                    chat1 = await self.get_chat(self.OTH_CHANNEL)
                    chat2 = await self.get_chat(chat_id)
                    try:
                        await message.reply_text(
                            f"**Anda harus bergabung dengan channel saya, untuk menggunakan saya.**",
                            disable_web_page_preview=True,
                            reply_markup=InlineKeyboardMarkup(
                                self.fsub_markup2(
                                    message, chat1.invite_link, chat2.invite_link,
                                )
                            ),
                        )
                        await message.stop_propagation()
                    except ChatWriteForbidden:
                        pass
            return await func(client, message)
  
        return wrapper
