import asyncio
import base64

from pyrogram.errors import FloodWait


class Content:
    async def encode(self, string):
        string_bytes = string.encode("ascii")
        base64_bytes = base64.urlsafe_b64encode(string_bytes)
        base64_string = (base64_bytes.decode("ascii")).strip("=")
        return base64_string


    async def decode(self, base64_string):
        base64_string = base64_string.strip("=")
        base64_bytes = (base64_string + "=" * (-len(base64_string) % 4)).encode("ascii")
        string_bytes = base64.urlsafe_b64decode(base64_bytes)
        string = string_bytes.decode("ascii")
        return string
  

    async def get_message(self, message_ids):
        messages = []
        total_messages = 0
        while total_messages != len(message_ids):
            temb_ids = message_ids[total_messages : total_messages + 200]
            try:
                msgs = await self.get_messages(
                    chat_id=self.channel_db.id, message_ids=temb_ids
                )
            except FloodWait as e:
                await asyncio.sleep(e.value)
                msgs = await self.get_messages(
                    chat_id=self.channel_db.id, message_ids=temb_ids
                )
            except BaseException:
                pass
            total_messages += len(temb_ids)
            messages.extend(msgs)
        return messages