import os
import asyncio 

from pyrogram.types import InputMediaVideo, InlineKeyboardMarkup
from pyrogram.errors import ChannelBanned, ChannelInvalid, ChannelPrivate, ChatIdInvalid, ChatInvalid, FloodWait


class Message:
    async def content_bub(self, message):
        post = await self.copy_message(
            self.BUB_INDEX, message.chat.id, message.id, caption="", reply_markup=None
            )
        msg = await self.get_messages(self.BUB_INDEX, post.id)
        thumb = await self.bubthumb(msg)
        await self.save_video2(msg, msg.video.file_name[:-4], msg.video.duration, msg.video.file_size, thumb)
        await self.send_photo(
            chat_id=self.BUB_CHANNEL, 
            photo=thumb, 
            caption=f"**Update video viral terbaru! 🔥**\n\n**🏷️ Judul:** {msg.video.file_name[:-4]}\n**⏱️ Durasi:** {self.timeformat(msg.video.duration)}\n**📂 Ukuran:** {self.sizeformat(msg.video.file_size)}",
            reply_markup=InlineKeyboardMarkup(self.search_bub())
        )
        
        
    async def sleep(self, message, chat_id, sec=0, delay=False):
        msg = None
        await asyncio.sleep(sec)
        if delay:
            msg = message
        return msg


    async def send_delay(self, message, chat_id, sec=0):

        if sec <= 600:  # 10 min
            asyncio.create_task(self.sleep(message, sec=sec, delay=True))
            return True
        else:
            self.logs.error("Fungsi send delay hanya dapat tidur selama 10 menit (600 detik)")
        

    async def send_index(self, message, to_chat):
        if message.video:
            return await self.send_video(
                chat_id=to_chat, video=message.video.file_id,
            )
        else:
            await message.delete()


    async def delete(self, message, chat_id):
        msg_ids = []
        async for msg in self.vip.get_chat_history(chat_id):
            msg_ids.append(msg.id)
            if len(msg_ids) >= 100:
                await self.delete_messages(
                    chat_id=chat_id, message_ids=msg_ids, revoke=True
                )
                msg_ids = []
            await self.delete_messages(
                chat_id=chat_id, message_ids=msg_ids, revoke=True
            )


    async def send(self, from_chat, chat_id):
        videos = []
        msg_ids = []
        async for msg in self.get_chat_history(from_chat):
            if msg.video:
                videos.append(
                    InputMediaVideo(media=msg.video.file_id)
                )
                msg_ids.append(msg.id)
                if len(videos) >= 9:    
                    await self.send_media_group(
                        chat_id=chat_id, media=videos, protect_content=True
                    )
                    await self.delete_messages(
                        chat_id=from_chat, message_ids=msg_ids, revoke=True
                    )
                    videos = []
                    msg_ids = []


    async def getprivate(self, client, message, msg_link):
        chat = ""
        msg_id = 0
        try:
            msg_id = int(msg_link.split("/")[-1])
        except ValueError:
            if '?single' in msg_link:
                link_ = msg_link.split("?single")[0]
                msg_id = int(link_.split("/")[-1])
            else:
                await message.edit_text("Link Tidak Valid !")
                return None
        if 't.me/c/' in msg_link:
            chat = int('-100' + str(msg_link.split("/")[-2]))
            file = ""
            try:
                if message.from_user.id not in self.OWNER_ID:
                    if chat in self.BLCHAT:
                        return await message.edit_text("Tidak dapat menyimpan dari obrolan ini !")
                edit = await message.edit_text("`Memproses...`")
                msg = await client.get_messages(chat, msg_id)
                file = await msg.download(file_name="./resource/cache/")
                if str(file).split(".")[-1] in ['mkv', 'mp4', 'webm', 'mpe4', 'mpeg']:
                    if str(file).split(".")[-1] in ['webm', 'mkv', 'mpe4', 'mpeg']:
                        path = str(file).split(".")[0] + ".mp4"
                        os.rename(file, path) 
                        file = str(file).split(".")[0] + ".mp4"
                    await edit.edit_text("`Uploading Video !`")
                    video, thumb, width, height, duration = await self.getvideo(file)
                    await message.reply_video(
                        video=video, thumb=thumb, width=width, height=height, 
                        duration=duration, supports_streaming=True,                        
                    )
                    await self.send_video(
                        chat_id=self.BDB_CACHE, video=video,
                        thumb=thumb, width=width, height=height, 
                        duration=duration, supports_streaming=True,
                    )
                    try:
                        os.remove(video)
                        os.remove(thumb)
                    except BaseException:
                        pass
                elif str(file).split(".")[-1] in ['jpg', 'jpeg', 'png', 'webp']:
                    await edit.edit_text("`Uploading Photo !`")
                    await message.reply_photo(photo=file)
                    await self.send_photo(
                        chat_id=self.BDB_CACHE, photo=file,
                    )
                    try:
                        os.remove(file)
                    except BaseException:
                        pass
                else:
                    await edit.edit_text("`Uploading Document !`")
                    await message.reply_document(document=file)
                    await self.send_document(
                        chat_id=self.BDB_CACHE, document=file,
                    )
                    try:
                        os.remove(file)
                    except BaseException:
                        pass
                await edit.delete()
                return None
            except (ChannelBanned, ChannelInvalid, ChannelPrivate, ChatIdInvalid, ChatInvalid):
                await message.edit_text("Sudahkah Anda bergabung dengan saluran tersebut?")
                return None
            except FloodWait as fw:
                await message.edit_text(f"Coba lagi setelah {fw.value} detik karena menunggu FloodWait dari telegram.")
                return None
            except Exception as e:
                self.logs.error(e)
                await message.edit_text(f"**ERROR**\n\n`{e}`")
                if os.path.isfile(file) == True:
                    os.remove(file)
                return None
        else:
            edit = await message.edit_text("`Memproses...`")
            chat =  msg_link.split("/")[-2]
            try:
                await client.copy_message(message.chat.id, chat, msg_id)
            except FloodWait as fw:
                await message.edit_text(f"Coba lagi setelah {fw.value} detik karena menunggu FloodWait dari telegram.")
                return None
            except Exception as e:
                self.logs.error(e)
                await message.edit_text(f"**ERROR**\n\n`{e}`")
                return None
            await edit.delete()
            return None