import re
import textwrap
from telegraph import upload_file
from PIL import Image, ImageDraw, ImageEnhance, ImageFilter, ImageFont, ImageOps


def changeImageSize(maxWidth, maxHeight, image):
    widthRatio = maxWidth / image.size[0]
    heightRatio = maxHeight / image.size[1]
    newWidth = int(widthRatio * image.size[0])
    newHeight = int(heightRatio * image.size[1])
    newImage = image.resize((newWidth, newHeight))
    return newImage


class Thumbnail:
    async def genthumb(self, img, msgid, title):
        try:
            title = re.sub("\\W+", " ", title)
            image = Image.open(img)
            image1 = changeImageSize(1280, 720, image)
            image2 = image1.convert("RGBA")
            picture = Image.open("resource/thumbnail/logo.png")
            background = image2.filter(ImageFilter.BoxBlur(10))
            enhancer = ImageEnhance.Brightness(background)
            background = enhancer.enhance(0.6)
            Xcenter = picture.width / 2
            Ycenter = picture.height / 2
            x1 = Xcenter - 250
            y1 = Ycenter - 250
            x2 = Xcenter + 250
            y2 = Ycenter + 250
            logo1 = picture.crop((x1, y1, x2, y2))
            logo1.thumbnail((520, 520), Image.ANTIALIAS)
            logo2 = ImageOps.expand(logo1, border=15, fill="lime")
            background.paste(logo2, (50, 100))
            draw = ImageDraw.Draw(background)
            font = ImageFont.truetype("resource/fonts/font2.ttf", 50)
            font2 = ImageFont.truetype("resource/fonts/font2.ttf", 70)
            arial = ImageFont.truetype("resource/fonts/font2.ttf", 40)
            name_font = ImageFont.truetype("resource/fonts/font.ttf", 40)
            para = textwrap.wrap(title, width=28)
            j = 0
            draw.text(
                (215, 5),
                f"Jangan lupa berlangganan OTH Premium",
                fill="lime",
                font=name_font,
            )
            draw.text(
                (600, 150),
                f"On The Herd",
                fill="lime",
                stroke_width=2,
                stroke_fill="lime",
                font=font2,
            )
            for line in para:
                if j == 1:
                    j += 1
                    draw.text(
                        (600, 340),
                        f"{line}",
                        fill="lime",
                        stroke_width=1,
                        stroke_fill="lime",
                        font=font,
                    )
                if j == 0:
                    j += 1
                    draw.text(
                        (600, 280),
                        f"{line}",
                        fill="lime",
                        stroke_width=1,
                        stroke_fill="lime",
                        font=font,
                    )

            draw.text(
                (600, 450),
                f"Channel : @OnTheHerd",
                fill="lime",
                font=arial,
            )
            draw.text(
                (600, 500),
                f"Backup : @OTHBackup",
                fill="lime",
                font=arial,
            )
            draw.text(
                (600, 550),
                f"Group : @OTHDiskusi",
                fill="lime",
                font=arial,
            )
            background.save(f"resource/thumbnail/{msgid}.png")
            return f"resource/thumbnail/{msgid}.png"
        except Exception as e:
            self.logs.warning(e)


    async def pobthumb(self, img, msgid):
        try:
            title = re.sub("\\W+", " ", "Jangan lupa TopUp Berlian biar bisa download Video")
            image = Image.open(img)
            image1 = changeImageSize(1280, 720, image)
            image2 = image1.convert("RGBA")
            picture = Image.open("resource/thumbnail/poblogo.png")
            background = image2.filter(ImageFilter.BoxBlur(8))
            enhancer = ImageEnhance.Brightness(background)
            background = enhancer.enhance(0.6)
            Xcenter = picture.width / 2
            Ycenter = picture.height / 2
            x1 = Xcenter - 250
            y1 = Ycenter - 250
            x2 = Xcenter + 250
            y2 = Ycenter + 250
            logo1 = picture.crop((x1, y1, x2, y2))
            logo1.thumbnail((520, 520), Image.ANTIALIAS)
            logo2 = ImageOps.expand(logo1, border=15, fill="aqua")
            background.paste(logo2, (50, 100))
            draw = ImageDraw.Draw(background)
            font = ImageFont.truetype("resource/fonts/font2.ttf", 50)
            font2 = ImageFont.truetype("resource/fonts/font2.ttf", 60)
            para = textwrap.wrap(title, width=25)
            j = 0
            draw.text(
                (600, 190),
                f"Pemersatu Orang Baik",
                fill="aqua",
                stroke_width=2,
                stroke_fill="aqua",
                font=font2,
            )
            for line in para:
                if j == 1:
                    j += 1
                    draw.text(
                        (600, 380),
                        f"{line}",
                        fill="aqua",
                        stroke_width=1,
                        stroke_fill="aqua",
                        font=font,
                    )
                if j == 0:
                    j += 1
                    draw.text(
                        (600, 320),
                        f"{line}",
                        fill="aqua",
                        stroke_width=1,
                        stroke_fill="aqua",
                        font=font,
                    )
            background.save(f"resource/thumbnail/{msgid}.png")
            return f"resource/thumbnail/{msgid}.png"
        except Exception as e:
            self.logs.warning(e)

            
    async def bubthumb(self, message):
        duration = self.timeformat(message.video.duration)
        size = self.sizeformat(message.video.file_size)
        img = await self.download_media(message.video.thumbs[0].file_id)
        try:
            title = re.sub("\\W+", " ", message.video.file_name[:-4])
            image = Image.open(img)
            image1 = changeImageSize(1280, 720, image)
            image2 = image1.convert("RGBA")
            picture = Image.open("resource/thumbnail/bublogo.png")
            background = image2.filter(ImageFilter.BoxBlur(10))
            enhancer = ImageEnhance.Brightness(background)
            background = enhancer.enhance(0.6)
            Xcenter = picture.width / 2
            Ycenter = picture.height / 2
            x1 = Xcenter - 250
            y1 = Ycenter - 250
            x2 = Xcenter + 250
            y2 = Ycenter + 250
            logo1 = picture.crop((x1, y1, x2, y2))
            logo1.thumbnail((520, 520), Image.ANTIALIAS)
            logo2 = ImageOps.expand(logo1, border=15, fill="white")
            background.paste(logo2, (50, 100))
            draw = ImageDraw.Draw(background)
            font = ImageFont.truetype("resource/fonts/font2.ttf", 50)
            font2 = ImageFont.truetype("resource/fonts/font2.ttf", 70)
            arial = ImageFont.truetype("resource/fonts/font2.ttf", 40)
            name_font = ImageFont.truetype("resource/fonts/font.ttf", 40)
            para = textwrap.wrap(title, width=28)
            j = 0
            draw.text(
                (215, 5),
                f"Jangan lupa berlangganan Bokep UserBot",
                fill="white",
                font=name_font,
            )
            draw.text(
                (600, 150),
                f"Bokep UserBot",
                fill="white",
                stroke_width=2,
                stroke_fill="white",
                font=font2,
            )
            for line in para:
                if j == 1:
                    j += 1
                    draw.text(
                        (600, 340),
                        f"{line}",
                        fill="white",
                        stroke_width=1,
                        stroke_fill="white",
                        font=font,
                    )
                if j == 0:
                    j += 1
                    draw.text(
                        (600, 280),
                        f"{line}",
                        fill="white",
                        stroke_width=1,
                        stroke_fill="white",
                        font=font,
                    )

            draw.text(
                (600, 450),
                f"Durasi : {duration}",
                fill="white",
                font=arial,
            )
            draw.text(
                (600, 500),
                f"Ukuran : {size}",
                fill="white",
                font=arial,
            )
            draw.text(
                (600, 550),
                f"Channel : t.me/BokepUserBots",
                fill="white",
                font=arial,
            )
            background.save(f"resource/thumbnail/{message.id}.png")
            try:
                tlink = upload_file(f"resource/thumbnail/{message.id}.png")
            except Exception:
                tlink = upload_file(f"resource/thumbnail/{message.id}.png")
            return f"https://telegra.ph{tlink[0]}"
        except Exception as e:
            self.logs.warning(e)
