import random 
from urllib.parse import quote
from pyrogram.types import WebAppInfo, InlineKeyboardButton


class Inline:
    def start_markup(self):
        buttons = [
            [
                InlineKeyboardButton(text="⎡ Berlangganan On The Herd ⎦", callback_data="subscribe"),
            ],
            [
                InlineKeyboardButton(text="👤 Info Akun", callback_data="info"),
                InlineKeyboardButton(text="Tentang OTH ❓", callback_data="about"),
            ],
        ]
        return buttons


    def back_markup(self):
        buttons = [
            [
                InlineKeyboardButton(text="« Kembali", callback_data="start"),
            ],
        ]
        return buttons


    def share_markup(self):
        buttons = [
            [
                InlineKeyboardButton("⎡ Share Channel ⎦", url="https://t.me/share/url?url=" + quote(self.SHARE_TEXT)),
            ],
        ]
        return buttons


    def basic_markup(self, link):
        buttons = [
            [
                InlineKeyboardButton(text="⎡ Download Content File ⎦", url=link),
            ],
            [
                InlineKeyboardButton(text="⎡ Tutorial Download ⎦", url="https://t.me/OTHBackup/394"),
            ],
        ]
        return buttons


    def premium_markup(self, link, user):
        buttons = [
            [
                InlineKeyboardButton(text="⎡ Buka Content File ⎦", url=link),
            ],
            [
                InlineKeyboardButton(text=f"{user.first_name[:20]} OTH Premium √", user_id=user.id),
            ],
        ]
        return buttons


    def testimoni_markup(self):
        upvote = random.choice([600, 700, 800, 800, 1000])
        downvote = random.choice([1, 2, 3, 4, 5])
        votetext = f"{upvote}"
        if upvote > 1000:
            if upvote % 1000 >= 100:
                votetext = f"{upvote / 1000:.1f}K"
            else:
                votetext = f"{upvote // 1000}K"        
        buttons = [
            [
                InlineKeyboardButton(
                    text="Berlangganan On The Herd", 
                    url=f"https://t.me/{self.username}?start=prem"
                )
            ],
            [
                InlineKeyboardButton(
                    text=f"💯 {votetext}", callback_data=f"vote {upvote}|{downvote}"
                ),
                InlineKeyboardButton(
                    text=f"❌ {downvote}", callback_data="nots"
                )
            ],
        ]
        return buttons


    def vote_markup(self, upvote, downvote):
        votetext = f"{upvote}"
        if upvote > 1000:
            if upvote % 1000 >= 100:
                votetext = f"{upvote / 1000:.1f}K"
            else:
                votetext = f"{upvote // 1000}K"        
        buttons = [
            [
                InlineKeyboardButton(
                    text="Berlangganan On The Herd", 
                    url=f"https://t.me/{self.username}?start=prem"
                )
            ],
            [
                InlineKeyboardButton(
                    text=f"💯 {votetext}", callback_data=f"vote {upvote}|{downvote}"
                ),
                InlineKeyboardButton(
                    text=f"❌ {downvote}", callback_data="nots"
                )
            ],
        ]
        return buttons


    def subs_markup(self, user_id, digit):
        buttons = [
            [
                InlineKeyboardButton(
                    text="⎡ Redeem Promo Code ⎦", 
                    callback_data=f"plan {user_id}|{digit}|promo"
                )
            ],
            [
                InlineKeyboardButton(
                    text="⎡ Lanjutkan Berlangganan ⎦", 
                    callback_data=f"plan {user_id}|{digit}|none"
                )
            ],
            [
                InlineKeyboardButton(text="« Kembali", callback_data="start"),
            ],
        ]
        return buttons


    def promo_markup(self, user_id, digit, promo=None):
        buttons = [
            [
                InlineKeyboardButton(
                    text="⎡ Lanjutkan Ke Pembayaran ⎦", callback_data=f"service {user_id}|{digit}|promo" if promo == True
                    else f"service {user_id}|{digit}|nopromo"
                )
            ],
            [
                InlineKeyboardButton(text="❌ Batalkan ❌", callback_data="subscribe"),
            ],
        ]
        return buttons


    def plan_markup(self, user_id, digit, promo=None):
        buttons = [
            [
                InlineKeyboardButton(
                    text="⎡ Coba Premium Trial ⎦", callback_data=f"trial 100|{user_id}"
                )
            ],
            [
                InlineKeyboardButton(
                    text="-1", callback_data=f"plan {user_id}|{digit}|min"
                ),
                InlineKeyboardButton(
                    text="+1", callback_data=f"plan {user_id}|{digit}|max"
                )
            ],
            [
                InlineKeyboardButton(
                    text="⎡ Lanjutkan Ke Pembayaran ⎦", 
                    callback_data=f"service {user_id}|{digit}|promo" if promo == True
                    else f"service {user_id}|{digit}|nopromo"
                )
            ],
            [
                InlineKeyboardButton(text="« Kembali", callback_data="subscribe"),
            ],
        ]
        return buttons


    def service_markup(self, user_id, digit, promo=None):
        buttons = [
            [
                InlineKeyboardButton(
                    text="✅ Setuju & Lanjutkan ✅", 
                    callback_data=f"payment {user_id}|{digit}|promo" if promo == True
                    else f"payment {user_id}|{digit}|nopromo"
                )
            ],
            [
                InlineKeyboardButton(text="❌ Tidak Setuju & Batalkan ❌", callback_data="close"),
            ],
        ]
        return buttons


    def payment_markup(self, user_id, digit, promo=None):
        buttons = [
            [
                InlineKeyboardButton(
                    text="⎡ Qris ⎦", 
                    callback_data=f"qris {user_id}|{digit}|promo" if promo == True
                    else f"qris {user_id}|{digit}|nopromo"
                ),
                InlineKeyboardButton(
                    text="⎡ Dana ⎦",
                    callback_data=f"dana {user_id}|{digit}|promo" if promo == True
                    else f"dana {user_id}|{digit}|nopromo"
                )
            ],
            [
                InlineKeyboardButton(
                    text="⎡ Ovo ⎦", 
                    callback_data=f"ovo {user_id}|{digit}|promo" if promo == True
                    else f"ovo {user_id}|{digit}|nopromo"
                ),
                InlineKeyboardButton(
                    text="⎡ Gopay ⎦", 
                    callback_data=f"gopay {user_id}|{digit}|promo" if promo == True
                    else f"gopay {user_id}|{digit}|nopromo"
                )
            ],
            [
                InlineKeyboardButton(
                    text="« Kembali", 
                    callback_data=f"plan {user_id}|{digit}|none"
                )
            ],
        ]
        return buttons


    def confirm_markup(self, user_id, digit, promo=None):
        buttons = [
            [InlineKeyboardButton(
                text="✅ Konfirmasi ✅",
                callback_data=f"confirm {user_id}|{digit}|promo" if promo == True
                else f"confirm {user_id}|{digit}|nopromo"
            )]
        ]
        return buttons


    def approve_markup(self, user_id, digit, msgid):
        buttons = [
            [
                InlineKeyboardButton(
                    text="✅ Approve ✅", 
                    callback_data=f"approve {user_id}|{digit}|{msgid}"
                ),
            ],
            [
                InlineKeyboardButton(
                    text="❌ UnApprove ❌", callback_data="close"
                )
            ],
        ]
        return buttons


    def reload_markup(self):
        buttons = [
            [InlineKeyboardButton("🔄 Ulangi Berlangganan 🔄", callback_data="subscribe")]
        ]
        return buttons


    def send_markup(self, link):
        buttons = [
            [
                InlineKeyboardButton("⎡ Link Download ⎦", url=link),
            ],
            [
                InlineKeyboardButton("⎡ Share Channel ⎦", url="https://t.me/share/url?url=" + quote(self.SHARE_TEXT)),
                InlineKeyboardButton("⎡ OTH Backup ⎦", url="https://t.me/OTHBackup"),
            ],
            [
                InlineKeyboardButton("⎡ Berlangganan On The Herd ⎦", url=f"https://t.me/{self.username}?start=prem"),
            ],
        ]
        return buttons 


    def fsub_markup(self, message, link1, link2, link3, link4):
        buttons = [
            [
                InlineKeyboardButton(text="Channel 1", url=link1),
                InlineKeyboardButton(text="Channel 2", url=link2)
            ],
            [
                InlineKeyboardButton(text="Channel 3", url=link3),
                InlineKeyboardButton(text="Channel 4", url=link4)
            ],
        ]
        try:
            buttons.append(
                [InlineKeyboardButton(text="Coba Lagi", url=f"https://t.me/{self.username}?start={message.command[1]}")]
            )
        except IndexError:
            pass
        return buttons


    def fsub_markup2(self, message, link1, link2):
        buttons = [
            [
                InlineKeyboardButton(text="Channel 1", url=link1),
                InlineKeyboardButton(text="Channel 2", url=link2)
            ],
        ]
        try:
            buttons.append(
                [InlineKeyboardButton(text="Coba Lagi", url=f"https://t.me/{self.username}?start={message.command[1]}")]
            )
        except IndexError:
            pass
        return buttons
