import logging
import asyncio 
from logging.handlers import RotatingFileHandler


class Logger:
    logging.basicConfig(
        level=logging.INFO,
        format="[%(asctime)s - %(levelname)s] - %(name)s - %(message)s",
        datefmt="%d-%b-%y %H:%M:%S",
        handlers=[
            RotatingFileHandler("logs.txt", maxBytes=50000000, backupCount=10),
            logging.StreamHandler(),
        ],
    )
    logging.getLogger("pyrogram").setLevel(logging.WARNING)
    logs = logging.getLogger("pyroporn")
    loop = asyncio.get_event_loop_policy().get_event_loop()