from motor.motor_asyncio import AsyncIOMotorClient
from pyroporn.config import Config

from umongo import Instance, Document, fields


class Mongo:
    MONGODB = AsyncIOMotorClient(Config.MONGO_URL)
    MONGODB2 = AsyncIOMotorClient(Config.MONGO_URL2)
    db = MONGODB.OTHNew
    db2 = MONGODB2.VIPBot
    instance = Instance.from_db(db)
    instance2 = Instance.from_db(db2)

    @instance.register
    class Media(Document):
        file_id = fields.StrField(attribute='_id')
        file_name = fields.StrField(required=True)
        file_thumb = fields.StrField(allow_none=True)
        file_diamond = fields.StrField(allow_none=True)

        class Meta:
            indexes = ('$file_name', )
            collection_name = 'videos'

    @instance2.register
    class Media2(Document):
        file_id = fields.StrField(attribute='_id')
        file_name = fields.StrField(required=True)
        file_durr = fields.IntField(required=True)
        file_size = fields.IntField(allow_none=True)
        file_thumb = fields.StrField(allow_none=True)

        class Meta:
            indexes = ('$file_name', )
            collection_name = 'bub_videos'

    # OTH Database 
    votedb = db.voting
    premdb = db.premium
    promodb = db.promo
    onoffdb = db.onoffper
    trialdb = db.trial
    usersdb = db.users
    pricedb = db.price
    sessiondb = db.session

    # Pob
    diamonddb = db.diamond
    
    # Bub
    usersdb5 = db2.usersbub
    
    # PAP Database
    usersdb2 = db2.users
    ratingdb = db2.ratingusr

    # BDB Database
    ctndb = db2.content
    filedb = db2.uniquefile
    premdb2 = db2.premium
    admindb = db2.adminsbdb
    trialdb2 = db.trialbdb
    usersdb3 = db2.usersbdb

    # PMO Database
    admindb2 = db2.admins
    usersdb4 = db2.userspmo
    scheduledb = db2.schedule
