import re
import setuptools

requires = [
    "aiohttp",
    "dnspython",
    "ffmpeg-python",
    "hachoir",
    "motor==2.5.1",
    "moviepy==2.0.0.dev2",
    "marshmallow==3.14.1",
    "pyrogram==2.0.30",
    "pymongo[srv]==3.12.3",
    "pyromod==1.0",
    "pillow",
    "playwright",
    "telegraph",
    "tgcrypto==1.2.3",
    "umongo==3.0.1",
]

with open("pyroporn/version.py", encoding="utf-8") as f:
    version = re.findall(r"__version__ = \"(.+)\"", f.read())[0]

with open("README.md", encoding="utf-8") as f:
    readme = f.read()

setuptools.setup(
    name='pyroporn',
    version=version,
    author='TPro',
    author_email='',
    description='Best Porn Code for the Pyrogram Library.',
    license='MIT',
    classifiers=[
        'Programming Language :: Python',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.5',
        'Programming Language :: Python :: 3.6',
        'Programming Language :: Python :: 3.7',
        'Programming Language :: Python :: 3.8',
        'Programming Language :: Python :: 3.9',
        'Programming Language :: Python :: 3.10',
        'Topic :: Internet',
        'Topic :: Communications',
        'Topic :: Communications :: Chat',
        'Topic :: Software Development :: Libraries',
        'Topic :: Software Development :: Libraries :: Python Modules'
    ],
    keywords='telegram pyrogram porn bot userbot',
    url='https://github.com/OTHFamily/pyroporn',
    packages=setuptools.find_packages(),
    install_requires=requires,
    long_description=readme,
    long_description_content_type='text/markdown',
)